stages:
  - test-chart
  - build
  - publish

variables:
  LOG_LEVEL: "info"

include:
  - project: 'orbs/shared/ci-pipeline-utilities/deployment'
    file: '/deployment.yml'
    ref: 'v3.3.1'

.rule_definitions:
  rules:
  - &non_release_non_merge
    if: $CI_COMMIT_TAG || $CI_PIPELINE_SOURCE == "merge_request_event"
    when: never
  - &production_tag
    if: '$CI_COMMIT_REF_NAME =~ /^release\/([0-9]{1,3}\.){2}[0-9]{1,3}(-[^-]+)*$/'
  - &bump_chart
    if: '$CI_COMMIT_MESSAGE =~ /\[bump chart\]/'

.build_image:
  stage: build
  extends: .deploy
  before_script:
    - export THE_DOCKERFILE="Dockerfile-${IMAGE_SLUG}"
    - application=$(grep "LABEL name" "${THE_DOCKERFILE}" | cut -d"'" -f2)
    - tag=$(grep "LABEL version" "${THE_DOCKERFILE}" | cut -d"'" -f2)
    - application_image="${application}:${tag}"
    - export SRC_IMAGE="docker://gitlab-registry.oit.duke.edu/duke_openshift_users/community-supported-resources/duke-shibboleth/${application_image}"
    - export THE_IMAGE="docker://${CI_REGISTRY_IMAGE}/${application_image}"
  script:
    - ./bin/ci/copy_from_oit

test chart:
  rules:
  - *non_release_non_merge
  - changes:
    - "helm-chart/**/*"
    - "tests/mockup/deploy"
  - *bump_chart
  stage: test-chart
  script:
  - printf -- "++++++++ Testing helm chart ++++++++\n"
  - if bash tests/mockup/deploy all >/dev/null;then
      printf -- "Chart succeeded\n";
    else
      printf -- "Chart failed lint/test\n" >&2;
      exit 1;
    fi
  extends: .deploy

build_modshib:
  variables:
    IMAGE_SLUG: 'duke-httpd-modshib'
  extends: .build_image
  rules:
  - *non_release_non_merge
  - changes:
    - Dockerfile-duke-httpd-modshib

build_shibboleth:
  variables:
    IMAGE_SLUG: 'duke-shibboleth'
  extends: .build_image
  rules:
  - *non_release_non_merge
  - changes:
    - Dockerfile-duke-shibboleth

publish_chart:
  stage: publish
  extends: .publish_chart
  rules:
  - if: '$CI_COMMIT_REF_NAME =~ /^release\/([0-9]{1,3}\.){2}[0-9]{1,3}(-[^-]+)*$/'
